"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _path = require("path");
var _fs = require("fs");
var _parser = require("@babel/parser");
var _helperPluginUtils = require("@babel/helper-plugin-utils");
var _sync = _interopRequireDefault(require("resolve/sync"));
var _generator = _interopRequireDefault(require("@babel/generator"));
var _optimize = _interopRequireDefault(require("./optimize"));
var _escapeBraces = _interopRequireDefault(require("./escapeBraces"));
var _transformSvg = _interopRequireDefault(require("./transformSvg"));
var _fileExistsWithCaseSync = _interopRequireDefault(require("./fileExistsWithCaseSync"));
var _camelize = require("./camelize");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var ignoreRegex;
var _default = exports["default"] = (0, _helperPluginUtils.declare)(function (_ref) {
  var assertVersion = _ref.assertVersion,
    template = _ref.template,
    traverse = _ref.traverse,
    t = _ref.types;
  assertVersion(7);
  var specialPattern = function specialPattern(name) {
    return /^data-|^aria-/.test(name);
  };
  var formatValue = function formatValue(property) {
    var value;
    if (/^\d*$/gi.test(property.value.value)) {
      value = t.numericLiteral(parseInt(property.value.value, 10));
    } else {
      value = t.stringLiteral(property.value.value);
    }
    return value;
  };
  var createObjectExpressions = function createObjectExpressions(prop) {
    var resultArray = prop.value.expression.properties.map(function (property) {
      var value = formatValue(property);
      return t.objectProperty(t.identifier(property.key.name), value);
    });
    return t.objectExpression(resultArray);
  };
  var defaultValueTemplate = function defaultValueTemplate(_ref2) {
    var name = _ref2.name,
      identifier = _ref2.identifier,
      defaultValue = _ref2.defaultValue;
    var variable;
    if (specialPattern(name)) {
      variable = t.objectProperty(t.stringLiteral(name), t.assignmentPattern(identifier, defaultValue), false, true // shorthand
      );
    } else {
      variable = t.objectProperty(t.identifier(name), t.assignmentPattern(identifier, defaultValue), false, true // shorthand
      );
    }
    return variable;
  };
  var buildSvg = function buildSvg(_ref3) {
    var IS_EXPORT = _ref3.IS_EXPORT,
      EXPORT_FILENAME = _ref3.EXPORT_FILENAME,
      SVG_NAME = _ref3.SVG_NAME,
      tempSvgCode = _ref3.SVG_CODE;
    var SVG_CODE = tempSvgCode;
    var keepProps = [];
    var jsxKeepProps = [];
    var objectPattern = [];
    var jsxObjectPattern = [];
    SVG_CODE.openingElement.attributes.forEach(function (prop) {
      if (prop.type === 'JSXSpreadAttribute') {
        keepProps.push(t.restElement(t.identifier(prop.argument.name)));
        jsxKeepProps.push(prop);
        return;
      }
      var defaultValue;
      if (prop.value.type === 'JSXExpressionContainer') {
        defaultValue = createObjectExpressions(prop);
      } else {
        defaultValue = formatValue(prop);
      }
      objectPattern.push(defaultValueTemplate({
        name: prop.name.name.replace(/'/gi, ''),
        identifier: t.identifier((0, _camelize.hyphenToCamel)(prop.name.name).replace(/'/gi, '')),
        defaultValue: defaultValue
      }));
      jsxObjectPattern.push(t.jsxAttribute(t.jsxIdentifier(prop.name.name), t.jsxExpressionContainer(t.identifier((0, _camelize.hyphenToCamel)(prop.name.name).replace(/'/gi, '')))));
    });
    jsxObjectPattern = jsxObjectPattern.concat(jsxKeepProps);
    var blockStatement = t.blockStatement([t.returnStatement(t.identifier('SVG_CODE'))]);
    var objectPatternList = objectPattern.concat(keepProps);
    var functionName = t.identifier('SVG_NAME');
    var namedFunctionDeclaration = t.functionDeclaration(functionName,
    // No name for the function (anonymous)
    [t.objectPattern(objectPatternList)], blockStatement);
    var anonymousFunctionDeclaration = t.functionDeclaration(null,
    // No name for the function (anonymous)
    [t.objectPattern(objectPatternList)], blockStatement);
    SVG_CODE.openingElement.attributes = jsxObjectPattern;
    var namedTemplate = "\n      var SVG_NAME = ".concat((0, _generator["default"])(namedFunctionDeclaration, {
      jsescOption: {
        quotes: 'single'
      }
    }, '').code, ";\n      ").concat(IS_EXPORT ? 'export { SVG_NAME };' : '', "\n    ");
    var anonymousTemplate = "\n      var Component = ".concat((0, _generator["default"])(anonymousFunctionDeclaration, {
      jsescOption: {
        quotes: 'single'
      }
    }, '').code, ";\n      Component.displayName = 'EXPORT_FILENAME';\n      export default Component;\n    ");
    if (SVG_NAME !== 'default') {
      return template(namedTemplate)({
        SVG_NAME: SVG_NAME,
        SVG_CODE: SVG_CODE
      });
    }
    return template(anonymousTemplate)({
      SVG_CODE: SVG_CODE,
      EXPORT_FILENAME: EXPORT_FILENAME
    });
  };
  function applyPlugin(importIdentifier, importPath, path, state, isExport, exportFilename) {
    if (typeof importPath !== 'string') {
      throw new TypeError('`applyPlugin` `importPath` must be a string');
    }
    var _state$opts = state.opts,
      ignorePattern = _state$opts.ignorePattern,
      caseSensitive = _state$opts.caseSensitive,
      providedFilename = _state$opts.filename;
    var file = state.file,
      filename = state.filename;
    var newPath;
    if (ignorePattern) {
      // Only set the ignoreRegex once:
      ignoreRegex = ignoreRegex || new RegExp(ignorePattern);
      // Test if we should ignore this:
      if (ignoreRegex.test(importPath)) {
        return undefined;
      }
    }
    // This plugin only applies for SVGs:
    if ((0, _path.extname)(importPath) === '.svg') {
      var iconPath = filename || providedFilename;
      var svgPath = (0, _sync["default"])(importPath, {
        basedir: (0, _path.dirname)(iconPath),
        preserveSymlinks: true
      });
      if (caseSensitive && !(0, _fileExistsWithCaseSync["default"])(svgPath)) {
        throw new Error("File path didn't match case of file on disk: ".concat(svgPath));
      }
      if (!svgPath) {
        throw new Error("File path does not exist: ".concat(importPath));
      }
      var rawSource = (0, _fs.readFileSync)(svgPath, 'utf8');
      var optimizedSource = state.opts.svgo === false ? {
        data: rawSource
      } : (0, _optimize["default"])(rawSource, _objectSpread(_objectSpread({}, state.opts.svgo), {}, {
        path: svgPath
      }));
      var escapeSvgSource = (0, _escapeBraces["default"])(optimizedSource);
      var parsedSvgAst = (0, _parser.parse)(escapeSvgSource.data, {
        sourceType: 'module',
        plugins: ['jsx']
      });
      traverse(parsedSvgAst, (0, _transformSvg["default"])(t));
      var svgCode = traverse.removeProperties(parsedSvgAst.program.body[0].expression);
      var opts = {
        SVG_NAME: importIdentifier,
        SVG_CODE: svgCode,
        IS_EXPORT: isExport,
        EXPORT_FILENAME: exportFilename
      };
      var svgReplacement = buildSvg(opts);
      if (Array.isArray(svgReplacement)) {
        var _path$replaceWithMult = path.replaceWithMultiple(svgReplacement);
        var _path$replaceWithMult2 = _slicedToArray(_path$replaceWithMult, 1);
        newPath = _path$replaceWithMult2[0];
      } else {
        newPath = path.replaceWith(svgReplacement);
      }
      file.get('ensureReact')();
      file.set('ensureReact', function () {});
    }
    return newPath;
  }
  return {
    visitor: {
      Program: {
        enter: function enter(path, _ref4) {
          var file = _ref4.file,
            opts = _ref4.opts,
            filename = _ref4.filename;
          if (typeof filename === 'string' && typeof opts.filename !== 'undefined') {
            throw new TypeError('the "filename" option may only be provided when transforming code');
          }
          if (typeof filename === 'undefined' && typeof opts.filename !== 'string') {
            throw new TypeError('the "filename" option is required when transforming code');
          }
          if (!path.scope.hasBinding('React')) {
            var reactImportDeclaration = t.importDeclaration([t.importDefaultSpecifier(t.identifier('React'))], t.stringLiteral('react'));
            file.set('ensureReact', function () {
              var _path$unshiftContaine = path.unshiftContainer('body', reactImportDeclaration),
                _path$unshiftContaine2 = _slicedToArray(_path$unshiftContaine, 1),
                newPath = _path$unshiftContaine2[0];
              newPath.get('specifiers').forEach(function (specifier) {
                path.scope.registerBinding('module', specifier);
              });
            });
          } else {
            file.set('ensureReact', function () {});
          }
        }
      },
      CallExpression: function CallExpression(path, state) {
        var node = path.node;
        var requireArg = node.arguments.length > 0 ? node.arguments[0] : null;
        var filePath = t.isStringLiteral(requireArg) ? requireArg.value : null;
        if (node.callee.name === 'require' && t.isVariableDeclarator(path.parent) && filePath) {
          applyPlugin(path.parent.id, filePath, path.parentPath.parentPath, state);
        }
      },
      ImportDeclaration: function ImportDeclaration(path, state) {
        var node = path.node;
        if (node.specifiers.length > 0) {
          applyPlugin(node.specifiers[0].local, node.source.value, path, state);
        }
      },
      ExportNamedDeclaration: function ExportNamedDeclaration(path, state) {
        var node = path.node,
          scope = path.scope;
        if (node.specifiers.length > 0 && node.specifiers[0].local && node.specifiers[0].local.name === 'default') {
          var exportName = node.specifiers[0].exported.name;
          var filename = (0, _path.parse)(node.source.value).name;
          var newPath = applyPlugin(exportName, node.source.value, path, state, true, filename);
          if (newPath) {
            scope.registerDeclaration(newPath);
          }
        }
      }
    }
  };
});